/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */



/**
 * Le Framework de jeux JavaScript Phaser
 *
Phaser v2.0.5 - http://phaser.io - @photonstorm - (c) 2014 Photon Storm Ltd. 
https://github.com/photonstorm/phaser
http://examples.phaser.io/
 */



/**
 * Les variables du jeu
 * 
 */

var game; 
var S_INFOS = "Nombre de blocs affichés : ";
var nValue;// nombre de blocs affichés sur l'écran
var sTxtInfo;


document.addEventListener("DOMContentLoaded", Main, false); // appel au chargement de la page


/**
 * Fonction principale
 * Appelée au chargement de la page
 * 
 */
function Main()
{
    console.log("Main");

    // creation de la zone de jeu - API Canvas
    game = new Phaser.Game(720, 480, Phaser.AUTO, "idGameDiv", {preload:onPreload, create:onCreate, update:onUpdate});
}


/**
 * Préchargement des éléments du jeu
 * 
 * @return {[type]} [description]
 */
function onPreload()
{ 
    game.stage.backgroundColor = '#cccccc';// la couleur de fond du jeu
    game.load.image("bloc", "assets/box.png");// charge les éléments graphiques avec leurs identifiants
    game.load.image("box", "assets/box2.jpg");// charge les éléments graphiques avec leurs identifiants
}



/**
 * Création de la scène du jeu,
 * mise en place des graphismes...
 * 
 * @return {[type]} [description]
 */
function onCreate() 
{
    this.nValue = 0;

    var style = {
        font:"33px Arial",
        fill:"#fff"
    };
    sTxtInfo = game.add.text(10, 10, S_INFOS + nValue, style);

    game.physics.startSystem(Phaser.Physics.P2JS);// ajoute les lois de la physique sur le jeu
    game.physics.p2.gravity.y = 250;// ajoute la gravité
    game.input.onDown.add(addRemove, this);// écouteur sur les clics de la souris
}


/**
 * Ajoute et supprime des blocs
 * 
 * @param {[type]} oMouse [description]
 */
function addRemove(oMouse)
{
    // vérifie si la souris clique sur un bloc
    var oBlocClicked = game.physics.p2.hitTest(oMouse.position);
    
    // si clic dans le vide
    if(oBlocClicked.length==0)
    {
        var oBloc;
        var nTypeBloc = getRandomInt(1,2);// Génère un nombre entier aléatoire entre min (inclus) et max (inclus)

        // création d'un nouveau bloc
        if( nTypeBloc == 1 )
            oBloc = game.add.sprite(oMouse.position.x, oMouse.position.y, "bloc");
        else
            oBloc = game.add.sprite(oMouse.position.x, oMouse.position.y, "box");
        
        game.physics.p2.enable(oBloc);// active les lois de la physique sur le nouveau bloc créé
        
        this.nValue++;
    }
    else
    {
        // suppression du bloc
        oBlocClicked[0].parent.sprite.kill();
        this.nValue--;
    }
}


/**
 * Génère un nombre entier aléatoire entre min (inclus) et max (inclus)
 * 
 */
function getRandomInt(min, max)
{
    return Math.floor( Math.random() * (max - min + 1) ) + min;
}


/**
 * Appelée en continu pendant le jeu
 * 
 * @return {[type]} [description]
 */
function onUpdate() 
{
    sTxtInfo.text = S_INFOS + this.nValue;// mise à jour automatique du nombre de blocs
}



